/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package models;

import javax.faces.event.ActionEvent;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Named;
import jpa.entities.Usuarios;
import jpa.session.UsuariosFacade;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.sql.DataSource;
import jpa.entities.Entradas;
import jpa.entities.Peliculas;
import jpa.entities.Proyecciones;
import jpa.session.EntradasFacade;
import jpa.session.PeliculasFacade;
import jpa.session.ProyeccionesFacade;
import java.awt.image.BufferedImage;
import java.io.FileOutputStream;
import javax.imageio.ImageIO;
import java.awt.Color;
import java.awt.Graphics2D;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.util.UUID;
import org.primefaces.model.DefaultStreamedContent;
import org.primefaces.model.StreamedContent;
import java.util.Properties;
import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;




/**
 *
 * @author Cris
 */
@Named(value = "formulario")
@SessionScoped
public class Formulario implements Serializable{
    
    //Beans
    @EJB
    private UsuariosFacade usuariosFacade;
    private static List<Usuarios> usuarios;
    @EJB
    private PeliculasFacade peliculasFacade;
    private static List<Peliculas> peliculas;
    @EJB
    private ProyeccionesFacade proyeccionesFacade;
    private static List<Proyecciones> proyecciones;
    @EJB
    private EntradasFacade entradasFacade;
    private static List<Entradas> entradas;

    
    
    //Variables
    private String v_correo;
    private static String login_usuario;
    private static String login_contraseña;
    private String v_contraseña;
    
    private String nombrePelicula;
    private int duracionPelicula;
    private Date estrenoPelicula;
    private String fecha_estreno;
    
    private Date FechaHora;
    private String fecha_hora_proyeccion;

   

    
    
    
    private String v_nombre_registro;
    private String v_apellidos_registro;
    private String v_correo_registro;
    private int v_telefono_registro;
    private String v_contraseña_registro;
    private String v_contraseña_registro2;
    private String alerta;
    private String pelicula_elegida;
    private String proyeccion_elegida;
    private String historial_elegido;
    private String horario_elegido;
    
    private String pelicula_entrada;
    private String horario_entrada;
    private int id_proyeccion;
    private int n_entradas;
    private String codigo_entrada;
    private int id_usuario;
    private int id_sala;
    private int id_entrada;
    private int precio;






    


    

    

    
    
    

    private List<String> PeliculasCarteleraNombre = new ArrayList<String>();
    private List<String> PeliculasCarteleraPortada = new ArrayList<String>();
    private List<String> PeliculasCarteleraHorarios = new ArrayList<String>();
    private List<String> ProyeccionesPeliculas= new ArrayList<String>();

    private List<String> historial_peliculas_nombre= new ArrayList<String>();
     private List<String> historial_proyecciones_nombre= new ArrayList<String>();





    

    

    
    
    //De la base de datos
    private static int idusuario;
    private static String nombre;
    private static String apellidos;
    private static String correo;
    private static int telefono;
    private static String password;

    

    
    
    
    
    
    public Date getFechaHora() {
        return FechaHora;
    }

    public void setFechaHora(Date FechaHora) {
        this.FechaHora = FechaHora;
    }

    public String getFecha_hora_proyeccion() {
        return fecha_hora_proyeccion;
    }

    public void setFecha_hora_proyeccion(String fecha_hora_proyeccion) {
        this.fecha_hora_proyeccion = fecha_hora_proyeccion;
    }
    

    public String getProyeccion_elegida() {
        return proyeccion_elegida;
    }

    public void setProyeccion_elegida(String proyeccion_elegida) {
        this.proyeccion_elegida = proyeccion_elegida;
    }
    
    
    
    public String getFecha_estreno() {
        return fecha_estreno;
    }

    public void setFecha_estreno(String fecha_estreno) {
        this.fecha_estreno = fecha_estreno;
    }
    
    
    
    public String getNombrePelicula() {
        return nombrePelicula;
    }

    public void setNombrePelicula(String nombrePelicula) {
        this.nombrePelicula = nombrePelicula;
    }

    public int getDuracionPelicula() {
        return duracionPelicula;
    }

    public void setDuracionPelicula(int duracionPelicula) {
        this.duracionPelicula = duracionPelicula;
    }

    public Date getEstrenoPelicula() {
        return estrenoPelicula;
    }

    public void setEstrenoPelicula(Date estrenoPelicula) {
        this.estrenoPelicula = estrenoPelicula;
    }
    

    
    
    public String getHistorial_elegido() {
        return historial_elegido;
    }

    public void setHistorial_elegido(String historial_elegido) {
        this.historial_elegido = historial_elegido;
    }
    
    
    
    public List<String> getHistorial_peliculas_nombre() {
        return historial_peliculas_nombre;
    }

    public void setHistorial_peliculas_nombre(List<String> historial_peliculas_nombre) {
        this.historial_peliculas_nombre = historial_peliculas_nombre;
    }
    
    public List<String> getHistorial_proyecciones_nombre() {
        return historial_proyecciones_nombre;
    }

    public void setHistorial_proyecciones_nombre(List<String> historial_proyecciones_nombre) {
        this.historial_proyecciones_nombre = historial_proyecciones_nombre;
    }
    
    public int getPrecio() {
        return precio;
    }

    public void setPrecio(int precio) {
        this.precio = precio;
    }
    
    public int getId_entrada() {
        return id_entrada;
    }

    public void setId_entrada(int id_entrada) {
        this.id_entrada = id_entrada;
    }
    
    
    public int getId_sala() {
       return id_sala;
    }

    public void setId_sala(int id_sala) {
        this.id_sala = id_sala;
    }
    
    public int getId_usuario() {
       return id_usuario;
    }

    public void setId_usuario(int id_usuario) {
        this.id_usuario = id_usuario;
    }
    
    
    public String getCodigo_entrada() {
       return codigo_entrada;
    }

    public void setCodigo_entrada(String codigo_entrada) {
        this.codigo_entrada = codigo_entrada;
    }
    
    
    public int getId_proyeccion() {
        return id_proyeccion;
    }

    public void setId_proyeccion(int id_proyeccion) {
        this.id_proyeccion = id_proyeccion;
    }
    
    
    public String getPelicula_entrada() {
        return pelicula_entrada;
    }

    public void setPelicula_entrada(String pelicula_entrada) {
        this.pelicula_entrada = pelicula_entrada;
    }

    public String getHorario_entrada() {
        return horario_entrada;
    }

    public void setHorario_entrada(String horario_entrada) {
        this.horario_entrada = horario_entrada;
    }
    
    
    public int getN_entradas() {
        return n_entradas;
    }

    public void setN_entradas(int n_entradas) {
        this.n_entradas = n_entradas;
    }
    
    
    
    public String getHorario_elegido() {
        return horario_elegido;
    }

    public void setHorario_elegido(String horario_elegido) {
        this.horario_elegido = horario_elegido;
    }
    
    
    
    public String getPelicula_elegida() {
        return pelicula_elegida;
    }

    public void setPelicula_elegida(String pelicula_elegida) {
        this.pelicula_elegida = pelicula_elegida;
    }
    
    public List<String> getProyeccionesPeliculas() {
        return ProyeccionesPeliculas;
    }

    public void setProyeccionesPeliculas(List<String> ProyeccionesPeliculas) {
        this.ProyeccionesPeliculas = ProyeccionesPeliculas;
    }
    
    
    public List<String> getPeliculasCarteleraHorarios() {
        return PeliculasCarteleraHorarios;
    }

    public void setPeliculasCarteleraHorarios(List<String> PeliculasCarteleraHorarios) {
        this.PeliculasCarteleraHorarios = PeliculasCarteleraHorarios;
    }
    
    
    
    public List<String> getPeliculasCarteleraPortada() {
        return PeliculasCarteleraPortada;
    }

    public void setPeliculasCarteleraPortada(List<String> PeliculasCarteleraPortada) {
        this.PeliculasCarteleraPortada = PeliculasCarteleraPortada;
    }
    
    
    public List<String> getPeliculasCarteleraNombre() {
        return PeliculasCarteleraNombre;
    }

    public void setPeliculasCarteleraNombre(List<String> PeliculasCarteleraNombre) {
        this.PeliculasCarteleraNombre = PeliculasCarteleraNombre;
    }
    
    
    

    
    
    
    public String getAlerta() {
        return alerta;
    }

    public void setAlerta(String alerta) {
        this.alerta = alerta;
    }
    
    
    
    public String getV_nombre_registro() {
       return v_nombre_registro;
    }

    public void setV_nombre_registro(String v_nombre_registro) {
        this.v_nombre_registro = v_nombre_registro;
    }

    public String getV_apellidos_registro() {
        return v_apellidos_registro;
    }

    public void setV_apellidos_registro(String v_apellidos_registro) {
        this.v_apellidos_registro = v_apellidos_registro;
    }

    public String getV_correo_registro() {
        return v_correo_registro;
    }

    public void setV_correo_registro(String v_correo_registro) {
        this.v_correo_registro = v_correo_registro;
    }

    public int getV_telefono_registro() {
        return v_telefono_registro;
    }

    public void setV_telefono_registro(int v_telefono_registro) {
        this.v_telefono_registro = v_telefono_registro;
    }

    public String getV_contraseña_registro() {
        return v_contraseña_registro;
    }

    public void setV_contraseña_registro(String v_contraseña_registro) {
        this.v_contraseña_registro = v_contraseña_registro;
    }
    
    public String getV_contraseña_registro2() {
        return v_contraseña_registro2;
    }

    public void setV_contraseña_registro2(String v_contraseña_registro2) {
        this.v_contraseña_registro2 = v_contraseña_registro2;
    }
    
    
    public String getV_contraseña() {
        return v_contraseña;
    }

    public void setV_contraseña(String v_contraseña) {
        this.v_contraseña = v_contraseña;
    }
    
    
    public static String getPassword() {
        return password;
    }

    public static void setPassword(String password) {
        Formulario.password = password;
    }

    public String getV_correo() {
        return v_correo;
    }

    public void setV_correo(String v_correo) {
        this.v_correo = v_correo;
    }
    

    public static int getIdusuario() {
        return idusuario;
    }

    public static void setIdusuario(int idusuario) {
        Formulario.idusuario = idusuario;
    }

    public static String getNombre() {
        return nombre;
    }

    public static void setNombre(String nombre) {
        Formulario.nombre = nombre;
    }

    public static String getApellidos() {
        return apellidos;
    }

    public static void setApellidos(String apellidos) {
        Formulario.apellidos = apellidos;
    }

    public static String getCorreo() {
        return correo;
    }

    public static void setCorreo(String correo) {
        Formulario.correo = correo;
    }

    public static int getTelefono() {
        return telefono;
    }

    public static void setTelefono(int telefono) {
        Formulario.telefono = telefono;
    }
    
    
    

    
  

        public void mandarCorreoEntrada() {
        // El correo gmail de envío
        String correoEnvia = "tfgcine@gmail.com";
        String claveCorreo = "1TFGcine.";

        // La configuración para enviar correo
        Properties properties = new Properties();
        properties.put("mail.smtp.host", "smtp.gmail.com");
        properties.put("mail.smtp.starttls.enable", "true");
        properties.put("mail.smtp.port", "587");
        properties.put("mail.smtp.auth", "true");
        properties.put("mail.user", correoEnvia);
        properties.put("mail.password", claveCorreo);

        // Obtener la sesion
        Session session = Session.getInstance(properties, null);

        try {
            // Crear el cuerpo del mensaje
            MimeMessage mimeMessage = new MimeMessage(session);

            // Agregar quien envía el correo
            mimeMessage.setFrom(new InternetAddress(correoEnvia, "TFG Cine"));

            // Los destinatarios
            InternetAddress[] internetAddresses = {
                //new InternetAddress(correo_envio)};
                new InternetAddress(v_correo)};

            // Agregar los destinatarios al mensaje
            mimeMessage.setRecipients(Message.RecipientType.TO,
                    internetAddresses);

            // Agregar el asunto al correo
            mimeMessage.setSubject("Entrada adquirida correctamente:");

            // Creo la parte del mensaje
            MimeBodyPart mimeBodyPart = new MimeBodyPart();
            mimeBodyPart.setText("Se ha realizado la compra de la entrada de la película: "+pelicula_entrada+ " a las "+horario_entrada+ ". Nº entradas: "+n_entradas);

            // Crear el multipart para agregar la parte del mensaje anterior
            Multipart multipart = new MimeMultipart();
            multipart.addBodyPart(mimeBodyPart);

            // Agregar el multipart al cuerpo del mensaje
            mimeMessage.setContent(multipart);

            // Enviar el mensaje
            Transport transport = session.getTransport("smtp");
            transport.connect(correoEnvia, claveCorreo);
            transport.sendMessage(mimeMessage, mimeMessage.getAllRecipients());
            transport.close();

        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }

       
       
       
       
       
       
       
    
    
    
    public String irPaginaVerProyeccion() {
        proyecciones = proyeccionesFacade.findAll(); 
        ProyeccionesPeliculas.clear();
        proyeccion_elegida = "";
        for (int i = 0; i < proyecciones.size(); i++) {
            ProyeccionesPeliculas.add(proyecciones.get(i).getIdpelicula().getNombre() + " " + proyecciones.get(i).getFechaHora().toInstant().atZone(ZoneId.systemDefault()).toLocalDateTime().toString().replace("T", " "));
        }
        return "verProyecciones";
    }
    
    
    
       
    public String irPaginaEProyeccion() {
        proyecciones = proyeccionesFacade.findAll(); 
        ProyeccionesPeliculas.clear();
        proyeccion_elegida = "";
        for (int i = 0; i < proyecciones.size(); i++) {
            ProyeccionesPeliculas.add(proyecciones.get(i).getIdpelicula().getNombre() + " " + proyecciones.get(i).getFechaHora().toInstant().atZone(ZoneId.systemDefault()).toLocalDateTime().toString().replace("T", " ") +  " ID: " + proyecciones.get(i).getIdproyeccion());
        }
        return "eliminarProyeccion";
    }
        
    
    public String eliminarProyecciones() {
        proyecciones = proyeccionesFacade.findAll();
        String[] partes = proyeccion_elegida.split("ID: ");
        proyeccion_elegida = partes[1];

        proyeccionesFacade.EliminarProyec(Integer.parseInt(proyeccion_elegida));
        nombrePeliculaCartelera();

        return "principal";
    }
    
    
    
    public String irPaginaEPelicula(){
        peliculas = peliculasFacade.findAll();
        ProyeccionesPeliculas.clear();
        pelicula_elegida = "";
        for(int i = 0; i < peliculas.size(); i++){
            ProyeccionesPeliculas.add(peliculas.get(i).getNombre() + " ID: " + peliculas.get(i).getIdpelicula());
        }
        return "eliminarPelicula";
    }
    
    
    public String eliminarPeliculas(){
        peliculas = peliculasFacade.findAll();
        String[] partes = pelicula_elegida.split("ID: ");
        pelicula_elegida = partes[1];
        
        peliculasFacade.EliminarPeli(Integer.parseInt(pelicula_elegida));
        nombrePeliculaCartelera();
        
        return "principal";
    }

    
    
    
    
    
    
    
    
  
    
    
    public String addPelicula(){
        peliculas = peliculasFacade.findAll();
        proyecciones = proyeccionesFacade.findAll();
        int peliculasEnCartelera = 0;
        
        for(int i = 0; i < peliculas.size(); i++){
            if(peliculas.get(i).getEnCartelera().equalsIgnoreCase("SI")){
                peliculasEnCartelera++;
            } 
        }
        if(peliculasEnCartelera >=3){
            alerta = "Debe eliminar una película en proyección";
            return "paginaError";
        }
        
        //Insertar pelicula
        String[] partes = estrenoPelicula.toInstant().atZone(ZoneId.systemDefault()).toLocalDateTime().toString().split("T");
        fecha_estreno = partes[0];
        peliculasFacade.InsertarPelicula(nombrePelicula, duracionPelicula, fecha_estreno, "SI");
        
        nombrePeliculaCartelera();
        return "principal";
    }
    
    
    
    
    
    
    
    public String irPaginaProyeccion(){
        peliculas = peliculasFacade.findAll();
        ProyeccionesPeliculas.clear();
        pelicula_elegida = "";
        for(int i = 0; i < peliculas.size(); i++){
            ProyeccionesPeliculas.add(peliculas.get(i).getNombre() + " ID: " + peliculas.get(i).getIdpelicula());
        }
        return "insertarProyeccion";
    }
    
    
    public String addProyeccion() throws InterruptedException{
        peliculas = peliculasFacade.findAll();
        proyecciones = proyeccionesFacade.findAll(); 
        int peliculasEnCartelera = 0;
        String[] partes = pelicula_elegida.split("ID: ");
        pelicula_elegida = partes[1];
        
        fecha_hora_proyeccion = FechaHora.toInstant().atZone(ZoneId.systemDefault()).toLocalDateTime().toString().replace("T", " ");
        
        
        for(int i = 0; i < peliculas.size(); i++){
            if(peliculas.get(i).getEnCartelera().equalsIgnoreCase("SI")){
                peliculasEnCartelera++;
            } 
        }
        
        for(int i = 0; i < proyecciones.size(); i++){
            if(proyecciones.get(i).getIdpelicula().getIdpelicula() == Integer.parseInt(pelicula_elegida) && proyecciones.get(i).getIdpelicula().getEnCartelera().equalsIgnoreCase("SI")){
                    proyeccionesFacade.InsertarProyeccion(fecha_hora_proyeccion, 200, Integer.parseInt(pelicula_elegida), 1);
                    nombrePeliculaCartelera();
                    return "principal";
            }   
        }
        
        if (peliculasEnCartelera > 3) {
            alerta = "Debe eliminar una película en proyección";
            return "error";
        } else {
            proyeccionesFacade.InsertarProyeccion(fecha_hora_proyeccion, 200, Integer.parseInt(pelicula_elegida), 1);
            nombrePeliculaCartelera();
            return "principal";
        }
        
        
    }
    

    
   
    
    public void nombrePeliculaCartelera() {
        ProyeccionesPeliculas.clear();
        historial_peliculas_nombre.clear();
        peliculas = peliculasFacade.findAll();
        proyecciones = proyeccionesFacade.findAll();  
        
        for(int i = 0; i < peliculas.size(); i++){
            if(peliculas.get(i).getEnCartelera().equalsIgnoreCase("SI")){
                historial_peliculas_nombre.add(peliculas.get(i).getNombre());
            }
        }
    
    }
    
    
   

    public boolean validate(String user, String password) {
	usuarios = usuariosFacade.findAll();
        if (v_correo.equalsIgnoreCase("admin")) {
            for (int i = 0; i <= usuarios.size() - 1; i++) {
                if (usuarios.get(i).getCorreo().equalsIgnoreCase(v_correo) && usuarios.get(i).getPassword().equalsIgnoreCase(v_contraseña)) {
                    login_contraseña = usuarios.get(i).getPassword();
                    login_usuario = usuarios.get(i).getCorreo();
                    id_usuario = usuarios.get(i).getIdusuario();
                    return true;
                }
            }
        }
        
        return false;
		
		
    }
    
    public String validateUsernamePassword() {
        boolean valid = validate(v_correo, v_contraseña);
        if (valid) {
            HttpSession session = SessionUtils.getSession();
            session.setAttribute("username", v_correo);
            login_usuario = v_correo;
            return "principal";
        } else {
            alerta = "Logeo de Administración erroneo";
            return "paginaError";
        }
    }

	//logout event, invalidate session
	public String logout() {
		HttpSession session = SessionUtils.getSession();
		session.invalidate();
		return "login";
	}

    public void addMessage(String summary, String detail) {
        FacesMessage message = new FacesMessage(FacesMessage.SEVERITY_WARN, summary, detail);
        FacesContext.getCurrentInstance().addMessage(null, message);
    }
    
    

    
    
}
