/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jpa.session;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import jpa.entities.Entradas;

/**
 *
 * @author Cris
 */
@Stateless
public class EntradasFacade extends AbstractFacade<Entradas> {

    @PersistenceContext(unitName = "TFGCinePU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public EntradasFacade() {
        super(Entradas.class);
    }
    
    
    public void InsertarEntrada(String codigo, int idproyeccion, int idusuario, int idsala) {
        String INSERT_SQL = "INSERT INTO entradas (codigo, idproyeccion, idusuario, idsala) VALUES (?, ?, ?, ?);";
        em.createNativeQuery(INSERT_SQL).setParameter(1, codigo).setParameter(2, idproyeccion).setParameter(3, idusuario).setParameter(4, idsala).executeUpdate();
    }
}
