/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jpa.session;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import jpa.entities.Proyecciones;

/**
 *
 * @author Cris
 */
@Stateless
public class ProyeccionesFacade extends AbstractFacade<Proyecciones> {

    @PersistenceContext(unitName = "TFGCinePU")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public ProyeccionesFacade() {
        super(Proyecciones.class);
    }
    
    public List ProyeccionesPeliculas(int idpelicula){
        String SELECT_SQL = "SELECT proyecciones.fecha_hora FROM peliculas INNER JOIN proyecciones ON peliculas.idpelicula = proyecciones.idpelicula WHERE peliculas.idpelicula = ?;";
        return em.createNativeQuery(SELECT_SQL).setParameter(1, idpelicula).getResultList();
    }    

    public void InsertarEntrada(String codigo, String idproyeccion, String idusuario, int idsala){
        String INSERT_SQL = "INSERT INTO entradas (codigo, idproyeccion, idusuario, idsala) VALUES (?, ?, ?, 1);";
        em.createNativeQuery(INSERT_SQL).setParameter(1, codigo).setParameter(2, idproyeccion).setParameter(3, idusuario).setParameter(4, idsala).executeUpdate();
    }
        

    
    
}
